﻿using System;

using Android.App;
using Android.Content;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Android.OS;

using Android.Provider;
using Java.IO;

using Camera;
using Android.Graphics.Drawables;
using System.Collections.Generic;
using Android.Content.PM;
using Android.Graphics;
using Android.Net;
using Android.Media;

namespace Camera
{
	[Activity (Label = "Camera", MainLauncher = true)]
	public class MainActivity : Activity
	{
		//https://developer.xamarin.com/recipes/android/media/video/record_video/



		VideoView video=null;
		MediaRecorder recorder;
		ImageView iv = null;
		string path ="";//video path
		protected override void OnCreate (Bundle bundle)
		{
			base.OnCreate (bundle);

			// Set our view from the "main" layout resource
			SetContentView (Resource.Layout.Main);

			// Get our button from the layout resource,
			// and attach an event to it
		
			Button button1 = FindViewById<Button> (Resource.Id.button1);
			Button button2 = FindViewById<Button> (Resource.Id.button2);
			Button stop = FindViewById<Button> (Resource.Id.button3);
			Button play = FindViewById<Button> (Resource.Id.button4);
			video = FindViewById<VideoView> (Resource.Id.videoView1);

			iv = FindViewById<ImageView> (Resource.Id.imageView1);

		

			if (IsThereAnAppToTakePictures ()) {
				CreateDirectoryForPictures ();
				button1.Click += delegate {
					CutImageByCamera ();


				};
				button2.Click += delegate {
					VIDEOImageByCamear();
				};

				stop.Click += delegate {
					if (recorder != null ) {
						recorder.Stop ();
						recorder.Release ();
					}
				};

				play.Click += delegate {
					var uri = Android.Net.Uri.Parse (path);
					video.SetVideoURI (uri);
					video.Start ();
				};
			}

		}

		private void CreateDirectoryForPictures ()
		{
			App._dir = new File (
				Android.OS.Environment.GetExternalStoragePublicDirectory ("/"
				), "CameraAppDemo");//Android.OS.Environment.DirectoryPictures
			if (!App._dir.Exists ()) {
				App._dir.Mkdirs ();
			}
		}

		protected override  void OnActivityResult (int requestCode, Result resultCode, Intent data)
		{
			base.OnActivityResult (requestCode, resultCode, data);

		

			Intent mediaScanIntent = new Intent (Intent.ActionMediaScannerScanFile);
			Android.Net.Uri contentUri = Android.Net.Uri.FromFile (App._file);
			mediaScanIntent.SetData (contentUri);
			SendBroadcast (mediaScanIntent);

			// Display in ImageView. We will resize the bitmap to fit the display.
			// Loading the full sized image will consume to much memory
			// and cause the application to crash.

			int height = iv.Height;//Resources.DisplayMetrics.HeightPixels;
			int width = iv.Height;
			App.bitmap = App._file.Path.LoadAndResizeBitmap (width, height);
			if (App.bitmap != null) {
				iv.SetImageBitmap (App.bitmap);
				App.bitmap = null;
			}

			// Dispose of the Java side bitmap.
			GC.Collect ();


		}

		private bool IsThereAnAppToTakePictures ()
		{
			Intent intent = new Intent (MediaStore.ActionImageCapture);
			IList<ResolveInfo> availableActivities =
				PackageManager.QueryIntentActivities (intent, PackageInfoFlags.MatchDefaultOnly);
			return availableActivities != null && availableActivities.Count > 0;
		}

		/// <summary>
		/// 调用摄像头拍摄
		/// </summary>
		private void CutImageByCamera ()
		{

			Intent intent = new Intent (MediaStore.ActionImageCapture);
			App._file = new File (App._dir, String.Format ("{0}.jpg", DateTime.Now.ToString ("yyyyMMddHHmmss")));
			intent.PutExtra (MediaStore.ExtraOutput, Android.Net.Uri.FromFile (App._file));
			StartActivityForResult (intent, 0);
		}

		/// <summary>
		/// VIDEOs the image by camear.
		/// </summary>
		private void VIDEOImageByCamear()
		{   path = Android.OS.Environment.ExternalStorageDirectory.AbsolutePath + "/test.mp4";
			video.StopPlayback ();
			recorder = new MediaRecorder ();
			recorder.SetVideoSource (VideoSource.Camera);
			recorder.SetAudioSource (AudioSource.Mic);
			recorder.SetOutputFormat (OutputFormat.Default);
			recorder.SetVideoEncoder (VideoEncoder.Default);
			recorder.SetAudioEncoder (AudioEncoder.Default);
			recorder.SetOutputFile (path);
			recorder.SetPreviewDisplay (video.Holder.Surface);
			recorder.Prepare ();
			recorder.Start ();   
		}



		protected override void OnDestroy ()
		{
			base.OnDestroy ();

			if (recorder != null) {
				recorder.Release ();
				recorder.Dispose ();
				recorder = null;
			}
		}
	}

	public static class App
	{
		public static File _file;
		public static File _dir;
		public static Bitmap bitmap;
	}

	public static class BitmapHelpers
	{
		public static Bitmap LoadAndResizeBitmap (this string fileName, int width, int height)
		{
			// First we get the the dimensions of the file on disk
			BitmapFactory.Options options = new BitmapFactory.Options { InJustDecodeBounds = true };
			BitmapFactory.DecodeFile (fileName, options);

			// Next we calculate the ratio that we need to resize the image by
			// in order to fit the requested dimensions.
			int outHeight = options.OutHeight;
			int outWidth = options.OutWidth;
			int inSampleSize = 1;

			if (outHeight > height || outWidth > width) {
				inSampleSize = outWidth > outHeight
					? outHeight / height
					: outWidth / width;
			}

			// Now we will load the image and have BitmapFactory resize it for us.
			options.InSampleSize = inSampleSize;
			options.InJustDecodeBounds = false;
			Bitmap resizedBitmap = BitmapFactory.DecodeFile (fileName, options);

			return resizedBitmap;
		}
	}
}


